# -*- coding: utf-8 -*-

import xbmc
import sys
import xbmcgui
import os
import shutil
import xbmcvfs
import json

if __name__ == "__main__":
    file_path = xbmc.getInfoLabel("ListItem.FileNameAndPath")
    db_id = xbmc.getInfoLabel("ListItem.DBID")
    dbtype = xbmc.getInfoLabel('ListItem.DBTYPE')
    
    xbmc.log(msg="db_id {}".format(db_id), level=xbmc.LOGERROR)
    xbmc.log(msg="db_type {}".format(dbtype), level=xbmc.LOGERROR)
    dialog = xbmcgui.Dialog()
    ret = dialog.yesno("Löschen", "Medium und den darüberliegenden Ordner löschen?")

    if ret == True:
        xbmc.log(msg="file_path {}".format(file_path), level=xbmc.LOGERROR)
        if "rar://" in file_path:
            first = file_path[:file_path.rfind("/")]
            first = first.replace("rar://", "")
            first = first.replace("%2f", "/")
            first = first.replace("%20", " ")
            first = first.replace("%3a", ":")
            
            if(dbtype=='episode'):
                current = first
                i = 1
                while xbmcvfs.exists(current):
                    xbmc.log(msg="current {}".format(current), level=xbmc.LOGERROR)
                    xbmcvfs.rmdir(current, True)
                    i+= 1
                    current = first.replace(".part1.rar", ".part{}.rar".format(i))
                response = xbmc.executeJSONRPC(json.dumps({'jsonrpc': '2.0', 'method': 'VideoLibrary.RemoveEpisode', 'params': {'episodeid': int(db_id)}, 'id': 1}))
            if(dbtype=='movie'):
                folder = first[:first.rfind("/")]
                xbmc.log(msg="folder {}".format(folder), level=xbmc.LOGERROR)
                xbmcvfs.rmdir("{}/".format(folder), True)
                response = xbmc.executeJSONRPC(json.dumps({'jsonrpc': '2.0', 'method': 'VideoLibrary.RemoveMovie', 'params': {'movieid': int(db_id)}, 'id': 1}))
            # Alternative
            #response = xbmc.executeJSONRPC(json.dumps('{"jsonrpc":"2.0", "method":"VideoLibrary.Clean","params": {"content":"video", "showdialogs" : false},"id":1}'))
            xbmc.log(msg="response {}".format(response), level=xbmc.LOGERROR)
        else: 
            folder = file_path[:file_path.rfind("/")]
            folder = folder.replace("%2f", "/")
            folder = folder.replace("%20", " ")
            folder = folder.replace("%3a", ":")
            
            xbmc.log(msg="dirname: {}".format(folder), level=xbmc.LOGERROR)
            folder = xbmcvfs.translatePath(folder)
            xbmc.log(msg="folder: {}".format(folder), level=xbmc.LOGERROR)
            if(dbtype=='episode'):
                xbmcvfs.delete(xbmcvfs.translatePath(file_path))
                os.remove(xbmcvfs.translatePath(file_path))
                response = xbmc.executeJSONRPC(json.dumps({'jsonrpc': '2.0', 'method': 'VideoLibrary.RemoveEpisode', 'params': {'episodeid': int(db_id)}, 'id': 1}))
            if(dbtype=='movie'):
                xbmcvfs.rmdir("{}/".format(folder), True)
                shutil.rmtree(folder, ignore_errors=True)
                response = xbmc.executeJSONRPC(json.dumps({'jsonrpc': '2.0', 'method': 'VideoLibrary.RemoveMovie', 'params': {'movieid': int(db_id)}, 'id': 1}))
            # Alternative
            #response = xbmc.executeJSONRPC(json.dumps('{"jsonrpc":"2.0", "method":"VideoLibrary.Clean","params": {"content":"video", "showdialogs" : false},"id":1}'))
            xbmc.log(msg="response {}".format(response), level=xbmc.LOGERROR)


